// symtable.cc
//
// uda - universal disassembler
// Date: 2003-05-04
//
// Copyright (c) 2002-2003 Ales Smrcka 
//
// This program is licensed under GNU Library GPL. See the file COPYING.
//
// This module contains interface of class Symbols - administration of symbols
//

#ifndef symtableH
#define symtableH

#include "udaclasses.h"
#include "shared.h"
#include <string>
using namespace std;

//! Gateway to use loading symbols from plugin. (Singleton, Proxy between Decoder and Plugins)
class Symbols : public AbstractSymbols {
    int _counter; //for automatic labels
public:
    Symbols(BinFileData &bfd) : AbstractSymbols(bfd) { _counter=0; }
    //! Looks for appropriate plugin and loads all symbols from the file or from mapfile
    virtual void Load(const char *filename=NULL);
    //! If address is not defined create new label
    bool checkaddress(const Address addr);
    //! true if symbol for this address is just defined
    bool defined(const Address addr);
    //! for mapping to symbols directly
    string &operator[](const Address addr);
    //!  find address corresponding to symbol
    Address findaddress(const string symbol, bool &defined);
};

extern Symbols *symbols;

#endif
