// udaclasses.h
//
// uda - universal disassembler
// Date: 2003-05-04
//
// Copyright (c) 2002-2003 Ales Smrcka 
//
// This program is licensed under GNU Library GPL. See the file COPYING.
//
// This module contains some definition of common classes and functions
// e.g. Exception, hex2uint, ...
//

#ifndef udaclassesH
#define udaclassesH
#include <string>
#include <iostream>
#include <iomanip>
using namespace std;

string uint2str(unsigned value);
string uint2hex(unsigned value, const string prefix="0x");
unsigned hex2uint(const string hex);
unsigned number2uint(const string num);
bool directory_exists(const string dir);
bool file_exists(const string filename);

//! void event
typedef void (*TVoidEvent)();

class BinFile;
class Section;
class Plugin;

class Exception {
protected:
    string value;
public:
    Exception(string s) { value=s; cerr<<dec<<setfill(' '); }
    virtual ~Exception() {}
    virtual void Print() { cerr<<"Disassembler error: "<<value<<endl; }
    operator string() { return value; }
};

extern string basedir;

#endif
